#include <PS2MouseHandler.h>
#include <DigiPotX9Cxxx.h>
#define MOUSE_DATA 5
#define MOUSE_CLOCK 6
#define LED 9  // The pin the LED is connected to

const int sensorPin = A0;
int sensorValue = 0;
float Vin = 5;
float Vout = 0;
float Rref = 1000;
float R = 0;
const int threshold = 250;

const int numReadings = 8;
int readings[numReadings];      // the readings from the analog input
int readIndex = 0;              // the index of the current reading
int total = 0;                  // the running total
int average = 0;                // the average

const int mousenumReadings = 8;
int mousereadings[mousenumReadings];      // the readings from the analog input
int mousereadIndex = 0;              // the index of the current reading
int mousetotal = 0;                  // the running total
int mouseaverage = 0;                // the average

PS2MouseHandler mouse(MOUSE_CLOCK, MOUSE_DATA, PS2_MOUSE_REMOTE);
DigiPot pot(2,3,4);

void setup ()
{
  Serial.begin(9600);
  pinMode(LED, OUTPUT); // Declare the LED as an output
  for (int thisReading = 0; thisReading < numReadings; thisReading++) {
  readings[thisReading] = 0;
  }
  for (int mousethisReading = 0; mousethisReading < mousenumReadings; mousethisReading++) {
  mousereadings[mousethisReading] = 0;
  }
  if(mouse.initialise() != 0){
    // mouse error
    Serial.println("mouse error");
  };
}

unsigned long last_run = millis();
int x = 0;
int y = 0;

int xspeed = 0;
int yspeed = 0;

void loop ()
{
  //read the resistor value of the rheostat foot pedal
  sensorValue = analogRead(sensorPin);
  Vout = (Vin * sensorValue) / 1023;
  int R = Rref * (1 / ((Vin / Vout) -1));

  //smooth the value of the foot pedal
  total = total - readings[readIndex];
  readings[readIndex] = R;
  total = total + readings[readIndex];
  readIndex = readIndex + 1;  
  if (readIndex >= numReadings) {
  readIndex = 0;
  }
  average = total / numReadings;

  //read mouse speed, assign it to variable x
  if (millis() - last_run > 4) {
    last_run = millis();
    mouse.get_data();  
    x = abs(mouse.x_movement())+abs(mouse.y_movement());
  }

  //smooth the value of the mouse
  mousetotal = mousetotal - mousereadings[mousereadIndex];
  mousereadings[mousereadIndex] = x;
  mousetotal = mousetotal + mousereadings[mousereadIndex];
  mousereadIndex = mousereadIndex + 1;  
  if (mousereadIndex >= mousenumReadings) {
  mousereadIndex = 0;
  }
  mouseaverage = mousetotal / mousenumReadings;
  
  // if the analog footpedal value is high enough, turn on the LED and allow the potentiometer to control the sewing machine:
  if (average > threshold) {
    digitalWrite(LED, HIGH);
    Serial.print("mouse speed: ");
    Serial.println((float(mouseaverage)/254)*99);
    pot.set((float(mouseaverage)/254)*99);
  } else {
    digitalWrite(LED, LOW);
  }

  delay(5);        // delay in between reads for stability
}
